searchNodes=[{"doc":"A implementation of RFC 6902 in pure Elixir.The patch can be a single change or a list of things that shall be changed. Therefore a list or a single JSON patch can be provided. Every patch belongs to a certain operation which influences the usage.","ref":"Jsonpatch.html","title":"Jsonpatch","type":"module"},{"doc":"Apply a Jsonpatch to a map or struct. The whole patch will not be applied when any path is invalid or any other error occured.Examplesiex&gt; patch = [ ...&gt; %Jsonpatch.Operation.Add{path: &quot;/age&quot;, value: 33}, ...&gt; %Jsonpatch.Operation.Replace{path: &quot;/hobbies/0&quot;, value: &quot;Elixir!&quot;}, ...&gt; %Jsonpatch.Operation.Replace{path: &quot;/married&quot;, value: true}, ...&gt; %Jsonpatch.Operation.Remove{path: &quot;/hobbies/1&quot;}, ...&gt; %Jsonpatch.Operation.Remove{path: &quot;/hobbies/2&quot;}, ...&gt; %Jsonpatch.Operation.Copy{from: &quot;/name&quot;, path: &quot;/surname&quot;}, ...&gt; %Jsonpatch.Operation.Move{from: &quot;/home&quot;, path: &quot;/work&quot;}, ...&gt; %Jsonpatch.Operation.Test{path: &quot;/name&quot;, value: &quot;Bob&quot;} ...&gt; ] iex&gt; target = %{&quot;name&quot; =&gt; &quot;Bob&quot;, &quot;married&quot; =&gt; false, &quot;hobbies&quot; =&gt; [&quot;Sport&quot;, &quot;Elixir&quot;, &quot;Football&quot;], &quot;home&quot; =&gt; &quot;Berlin&quot;} iex&gt; Jsonpatch.apply_patch(patch, target) %{&quot;name&quot; =&gt; &quot;Bob&quot;, &quot;married&quot; =&gt; true, &quot;hobbies&quot; =&gt; [&quot;Elixir!&quot;], &quot;age&quot; =&gt; 33, &quot;surname&quot; =&gt; &quot;Bob&quot;, &quot;work&quot; =&gt; &quot;Berlin&quot;} iex&gt; # Patch will not be applied if test fails. The target will not be changed. iex&gt; patch = [ ...&gt; %Jsonpatch.Operation.Add{path: &quot;/age&quot;, value: 33}, ...&gt; %Jsonpatch.Operation.Test{path: &quot;/name&quot;, value: &quot;Alice&quot;} ...&gt; ] iex&gt; target = %{&quot;name&quot; =&gt; &quot;Bob&quot;, &quot;married&quot; =&gt; false, &quot;hobbies&quot; =&gt; [&quot;Sport&quot;, &quot;Elixir&quot;, &quot;Football&quot;], &quot;home&quot; =&gt; &quot;Berlin&quot;} iex&gt; Jsonpatch.apply_patch(patch, target) %{&quot;name&quot; =&gt; &quot;Bob&quot;, &quot;married&quot; =&gt; false, &quot;hobbies&quot; =&gt; [&quot;Sport&quot;, &quot;Elixir&quot;, &quot;Football&quot;], &quot;home&quot; =&gt; &quot;Berlin&quot;}","ref":"Jsonpatch.html#apply_patch/2","title":"Jsonpatch.apply_patch/2","type":"function"},{"doc":"Creates &quot;add&quot;-operations by using the keys of the destination and check their existence in the source map. Source and destination has to be parsed to a flat map.","ref":"Jsonpatch.html#create_additions/3","title":"Jsonpatch.create_additions/3","type":"function"},{"doc":"Creates &quot;remove&quot;-operations by using the keys of the destination and check their existence in the source map. Source and destination has to be parsed to a flat map.","ref":"Jsonpatch.html#create_removes/3","title":"Jsonpatch.create_removes/3","type":"function"},{"doc":"Creates &quot;replace&quot;-operations by comparing keys and values of source and destination. The source and destination map have to be flat maps.","ref":"Jsonpatch.html#create_replaces/3","title":"Jsonpatch.create_replaces/3","type":"function"},{"doc":"Creates a patch from the difference of a source map to a target map.Examplesiex&gt; source = %{&quot;name&quot; =&gt; &quot;Bob&quot;, &quot;married&quot; =&gt; false, &quot;hobbies&quot; =&gt; [&quot;Elixir&quot;, &quot;Sport&quot;, &quot;Football&quot;]} iex&gt; destination = %{&quot;name&quot; =&gt; &quot;Bob&quot;, &quot;married&quot; =&gt; true, &quot;hobbies&quot; =&gt; [&quot;Elixir!&quot;], &quot;age&quot; =&gt; 33} iex&gt; Jsonpatch.diff(source, destination) [ %Add{path: &quot;/age&quot;, value: 33}, %Replace{path: &quot;/hobbies/0&quot;, value: &quot;Elixir!&quot;}, %Replace{path: &quot;/married&quot;, value: true}, %Remove{path: &quot;/hobbies/1&quot;}, %Remove{path: &quot;/hobbies/2&quot;} ]","ref":"Jsonpatch.html#diff/2","title":"Jsonpatch.diff/2","type":"function"},{"doc":"Cares of de- and encoding of json patches.","ref":"Jsonpatch.Coder.html","title":"Jsonpatch.Coder","type":"module"},{"doc":"Decodes a JSON patch string into patch structs.Examplesiex&gt; Jsonpatch.Coder.decode(&quot;{\\&quot;op\\&quot;: \\&quot;add\\&quot;,\\&quot;value\\&quot;: \\&quot;1\\&quot;,\\&quot;path\\&quot;: \\&quot;/age\\&quot;}&quot;) {:ok, %Jsonpatch.Operation.Add{path: &quot;/age&quot;, value: 1}}","ref":"Jsonpatch.Coder.html#decode/1","title":"Jsonpatch.Coder.decode/1","type":"function"},{"doc":"Encodes a patch into a JSON string.Examplesiex&gt; Jsonpatch.Coder.encode(%Jsonpatch.Operation.Add{path: &quot;/age&quot;, value: 1}) {:ok, &quot;{\\&quot;op\\&quot;: \\&quot;add\\&quot;,\\&quot;value\\&quot;: \\&quot;1\\&quot;,\\&quot;path\\&quot;: \\&quot;/age\\&quot;}&quot;}","ref":"Jsonpatch.Coder.html#encode/1","title":"Jsonpatch.Coder.encode/1","type":"function"},{"doc":"Forms structs in a flat format with paths instead of nested maps/structs.","ref":"Jsonpatch.FlatMap.html","title":"Jsonpatch.FlatMap","type":"module"},{"doc":"Parses any map with/out arrays to a flat map.Examplesiex&gt; source = %{&quot;a&quot; =&gt; &quot;b&quot;, &quot;c&quot; =&gt; [&quot;d&quot;, &quot;f&quot;], &quot;g&quot; =&gt; %{&quot;h&quot; =&gt; &quot;i&quot;}} iex&gt; Jsonpatch.FlatMap.parse(source) %{&quot;/a&quot; =&gt; &quot;b&quot;, &quot;/c/0&quot; =&gt; &quot;d&quot;, &quot;/c/1&quot; =&gt; &quot;f&quot;, &quot;/g/h&quot; =&gt; &quot;i&quot;}","ref":"Jsonpatch.FlatMap.html#parse/1","title":"Jsonpatch.FlatMap.parse/1","type":"function"},{"doc":"Maps JSON patches between regular maps and Jsonpatch.Operations.","ref":"Jsonpatch.Mapper.html","title":"Jsonpatch.Mapper","type":"module"},{"doc":"Creates JSON patch struct/s from a single or list maps which represents JSON patches.Examplesiex&gt; add_patch_map = %{&quot;op&quot; =&gt; &quot;add&quot;, &quot;path&quot; =&gt; &quot;/name&quot;, &quot;value&quot; =&gt; &quot;Alice&quot;} iex&gt; Jsonpatch.Mapper.from_map(add_patch_map) %Jsonpatch.Operation.Add{path: &quot;/name&quot;, value: &quot;Alice&quot;} iex&gt; unkown_patch_map = %{&quot;op&quot; =&gt; &quot;foo&quot;, &quot;path&quot; =&gt; &quot;/name&quot;, &quot;value&quot; =&gt; &quot;Alice&quot;} iex&gt; Jsonpatch.Mapper.from_map(unkown_patch_map) {:error, :invalid}","ref":"Jsonpatch.Mapper.html#from_map/1","title":"Jsonpatch.Mapper.from_map/1","type":"function"},{"doc":"","ref":"Jsonpatch.Mapper.html#to_map/1","title":"Jsonpatch.Mapper.to_map/1","type":"function"},{"doc":"Defines behaviour for apply a patch to a struct.","ref":"Jsonpatch.Operation.html","title":"Jsonpatch.Operation","type":"behaviour"},{"doc":"","ref":"Jsonpatch.Operation.html#c:apply_op/2","title":"Jsonpatch.Operation.apply_op/2","type":"callback"},{"doc":"Uses a JSON patch path to get the last map that this path references.Examplesiex&gt; path = &quot;/a/b/c/d&quot; iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; %{&quot;d&quot; =&gt; 1}}}} iex&gt; Jsonpatch.Operation.get_final_destination(target, path) {%{&quot;d&quot; =&gt; 1}, &quot;d&quot;} iex&gt; # Invalid path iex&gt; path = &quot;/a/e/c/d&quot; iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; %{&quot;d&quot; =&gt; 1}}}} iex&gt; Jsonpatch.Operation.get_final_destination(target, path) {:error, :invalid_path} iex&gt; path = &quot;/a/b/1/d&quot; iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; [true, %{&quot;d&quot; =&gt; 1}]}} iex&gt; Jsonpatch.Operation.get_final_destination(target, path) {%{&quot;d&quot; =&gt; 1}, &quot;d&quot;} iex&gt; # Invalid path iex&gt; path = &quot;/a/b/42/d&quot; iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; [true, %{&quot;d&quot; =&gt; 1}]}} iex&gt; Jsonpatch.Operation.get_final_destination(target, path) {:error, :invalid_path}","ref":"Jsonpatch.Operation.html#get_final_destination/2","title":"Jsonpatch.Operation.get_final_destination/2","type":"function"},{"doc":"Determines the sort value for the operation of a patch. This value assure in which order patches are applied. (Example: shall remove patches be applied before add patches?)","ref":"Jsonpatch.Operation.html#operation_sort_value?/1","title":"Jsonpatch.Operation.operation_sort_value?/1","type":"function"},{"doc":"Updatest a map reference by a given JSON patch path with the new final destination.Examplesiex&gt; path = &quot;/a/b/c/d&quot; iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; %{&quot;d&quot; =&gt; 1}}}} iex&gt; Jsonpatch.Operation.update_final_destination(target, %{&quot;e&quot; =&gt; 1}, path) %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; %{&quot;e&quot; =&gt; 1}}}}","ref":"Jsonpatch.Operation.html#update_final_destination/3","title":"Jsonpatch.Operation.update_final_destination/3","type":"function"},{"doc":"A valid Jsonpatch operation by RFC 6902","ref":"Jsonpatch.Operation.html#t:t/0","title":"Jsonpatch.Operation.t/0","type":"type"},{"doc":"The add operation is the operation for adding (as you might guess) values to a map or struct.","ref":"Jsonpatch.Operation.Add.html","title":"Jsonpatch.Operation.Add","type":"module"},{"doc":"Applies an add operation a struct/map.Examplesiex&gt; add = %Jsonpatch.Operation.Add{path: &quot;/a/b&quot;, value: 1} iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;c&quot; =&gt; false}} iex&gt; Jsonpatch.Operation.Add.apply_op(add, target) %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1, &quot;c&quot; =&gt; false}}","ref":"Jsonpatch.Operation.Add.html#apply_op/2","title":"Jsonpatch.Operation.Add.apply_op/2","type":"function"},{"doc":"","ref":"Jsonpatch.Operation.Add.html#t:t/0","title":"Jsonpatch.Operation.Add.t/0","type":"type"},{"doc":"Represents the handling of JSON patches with a copy operation.","ref":"Jsonpatch.Operation.Copy.html","title":"Jsonpatch.Operation.Copy","type":"module"},{"doc":"Copy the element referenced by the JSON patch path :from to to the other given path.Examplesiex&gt; copy = %Jsonpatch.Operation.Copy{from: &quot;/a/b&quot;, path: &quot;/a/e&quot;} iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; &quot;Bob&quot;}}, &quot;d&quot; =&gt; false} iex&gt; Jsonpatch.Operation.Copy.apply_op(copy, target) %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; &quot;Bob&quot;}, &quot;e&quot; =&gt; %{&quot;c&quot; =&gt; &quot;Bob&quot;}}, &quot;d&quot; =&gt; false}","ref":"Jsonpatch.Operation.Copy.html#apply_op/2","title":"Jsonpatch.Operation.Copy.apply_op/2","type":"function"},{"doc":"","ref":"Jsonpatch.Operation.Copy.html#t:t/0","title":"Jsonpatch.Operation.Copy.t/0","type":"type"},{"doc":"Move operations change the position of values in map or struct.","ref":"Jsonpatch.Operation.Move.html","title":"Jsonpatch.Operation.Move","type":"module"},{"doc":"Move the element referenced by the JSON patch path :from to to the other given path.Examplesiex&gt; move = %Jsonpatch.Operation.Move{from: &quot;/a/b&quot;, path: &quot;/a/e&quot;} iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; &quot;Bob&quot;}}, &quot;d&quot; =&gt; false} iex&gt; Jsonpatch.Operation.Move.apply_op(move, target) %{&quot;a&quot; =&gt; %{&quot;e&quot; =&gt; %{&quot;c&quot; =&gt; &quot;Bob&quot;}}, &quot;d&quot; =&gt; false}","ref":"Jsonpatch.Operation.Move.html#apply_op/2","title":"Jsonpatch.Operation.Move.apply_op/2","type":"function"},{"doc":"","ref":"Jsonpatch.Operation.Move.html#t:t/0","title":"Jsonpatch.Operation.Move.t/0","type":"type"},{"doc":"A JSON patch remove operation is responsible for removing values.","ref":"Jsonpatch.Operation.Remove.html","title":"Jsonpatch.Operation.Remove","type":"module"},{"doc":"Removes the element referenced by the JSON patch path.Examplesiex&gt; remove = %Jsonpatch.Operation.Remove{path: &quot;/a/b&quot;} iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; %{&quot;c&quot; =&gt; &quot;Bob&quot;}}, &quot;d&quot; =&gt; false} iex&gt; Jsonpatch.Operation.Remove.apply_op(remove, target) %{&quot;a&quot; =&gt; %{}, &quot;d&quot; =&gt; false}","ref":"Jsonpatch.Operation.Remove.html#apply_op/2","title":"Jsonpatch.Operation.Remove.apply_op/2","type":"function"},{"doc":"","ref":"Jsonpatch.Operation.Remove.html#t:t/0","title":"Jsonpatch.Operation.Remove.t/0","type":"type"},{"doc":"The replace module helps replacing values in maps and structs by paths.","ref":"Jsonpatch.Operation.Replace.html","title":"Jsonpatch.Operation.Replace","type":"module"},{"doc":"Applies an replace operation to a struct/map.Examplesiex&gt; add = %Jsonpatch.Operation.Replace{path: &quot;/a/b&quot;, value: 1} iex&gt; target = %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 2}} iex&gt; Jsonpatch.Operation.Replace.apply_op(add, target) %{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; 1}}","ref":"Jsonpatch.Operation.Replace.html#apply_op/2","title":"Jsonpatch.Operation.Replace.apply_op/2","type":"function"},{"doc":"","ref":"Jsonpatch.Operation.Replace.html#t:t/0","title":"Jsonpatch.Operation.Replace.t/0","type":"type"},{"doc":"A test operation in a JSON patch prevents the patch application or allows it.","ref":"Jsonpatch.Operation.Test.html","title":"Jsonpatch.Operation.Test","type":"module"},{"doc":"Tests if the value at the given path is equal to the provided value.Examplesiex&gt; test = %Jsonpatch.Operation.Test{path: &quot;/x/y&quot;, value: &quot;Bob&quot;} iex&gt; target = %{&quot;x&quot; =&gt; %{&quot;y&quot; =&gt; &quot;Bob&quot;}} iex&gt; Jsonpatch.Operation.Test.apply_op(test, target) :ok","ref":"Jsonpatch.Operation.Test.html#apply_op/2","title":"Jsonpatch.Operation.Test.apply_op/2","type":"function"},{"doc":"","ref":"Jsonpatch.Operation.Test.html#t:t/0","title":"Jsonpatch.Operation.Test.t/0","type":"type"}]